# -*- coding: utf-8 -*-
from __future__ import print_function
import os
import string
import sys
#import matplotlib as mpl
#import matplotlib.pyplot as plt
#import matplotlib.patches as mpatches
#from matplotlib.collections import PatchCollection
import scipy as sp
import scipy.linalg as la
import scipy.ndimage as ni
import scipy.optimize as opt
from scipy import random as rnd
#import nrrd

#####################################################################
# Input for Fig. 5

def rotMat(mat, angle):
    rot = sp.array([[sp.cos(angle),-sp.sin(angle)],[sp.sin(angle),sp.cos(angle)]])
    return sp.dot(sp.dot(rot,mat),rot.T)

testImg = sp.zeros((7,7,2,2))
testImg[3,3] = sp.array([[2,0],[0,0]])
testImg[2,3] = rotMat(sp.array([[2,0],[0,0]]), sp.pi*0.5)
testImg[3,4] = rotMat(sp.array([[2,0],[0,0]]), sp.pi*0.125)
testImg[4,3] = rotMat(sp.array([[2,0],[0,0]]), sp.pi*0.875)
testImg[3,2] = rotMat(sp.array([[2,0],[0,0]]), sp.pi*0.25)
testImg[1,3] = rotMat(sp.array([[2,0],[0,0]]), sp.pi*0.0)
testImg[3,5] = rotMat(sp.array([[2,0],[0,0]]), sp.pi*0.625)
testImg[5,3] = rotMat(sp.array([[2,0],[0,0]]), sp.pi*0.375)
testImg[3,1] = rotMat(sp.array([[2,0],[0,0]]), sp.pi*0.75)

#####################################################################
# Input for Figs. 3,4,9

##matCenter = sp.array([[2,0],[0,2]])
##matArmX = sp.array([[2,0],[0,0.5]])
##matArmY = sp.array([[0.5,0],[0,2]])
##matCorner = sp.identity(2)

##testImg = sp.zeros((21,21,2,2))
##testImg[0:7,0:7] = matCorner
##testImg[0:7,7:14] = matArmY
##testImg[0:7,14:21] = matCorner
##testImg[7:14,0:7] = matArmX
##testImg[7:14,7:14] = matCenter
##testImg[7:14,14:21] = matArmX
##testImg[14:21,0:7] = matCorner
##testImg[14:21,7:14] = matArmY
##testImg[14:21,14:21] = matCorner

##rot = sp.array([[sp.cos(sp.pi/4),-sp.sin(sp.pi/4)],[sp.sin(sp.pi/4),sp.cos(sp.pi/4)]])
##rotMatCenter = sp.dot(sp.dot(rot,matCenter),rot.T)
##rotMatArmX = sp.dot(sp.dot(rot,matArmX),rot.T)
##rotMatArmY = sp.dot(sp.dot(rot,matArmY),rot.T)
##rotMatCorner = sp.dot(sp.dot(rot,matCorner),rot.T)
##
##X,Y = sp.meshgrid(0.5+sp.r_[0:21],0.5+sp.r_[0:21])
##rotX = sp.cos(sp.pi/4)*(X-0.5*21) + sp.sin(sp.pi/4)*(Y-0.5*21) + 0.5*21 # Inverse rotation
##rotY = sp.cos(sp.pi/4)*(Y-0.5*21) - sp.sin(sp.pi/4)*(X-0.5*21) + 0.5*21
##rotTestImg = sp.einsum('ij,kl', sp.logical_and(rotX<7,rotY<7), rotMatCorner) + \
##             sp.einsum('ij,kl', sp.logical_and(rotX<7,sp.logical_and(rotY>=7,rotY<14)), rotMatArmX) + \
##             sp.einsum('ij,kl', sp.logical_and(rotX<7,rotY>=14), rotMatCorner) + \
##             sp.einsum('ij,kl', sp.logical_and(sp.logical_and(rotX>=7,rotX<14),rotY<7), rotMatArmY) + \
##             sp.einsum('ij,kl', sp.logical_and(sp.logical_and(rotX>=7,rotX<14),sp.logical_and(rotY>=7,rotY<14)), rotMatCenter) + \
##             sp.einsum('ij,kl', sp.logical_and(sp.logical_and(rotX>=7,rotX<14),rotY>=14), rotMatArmY) + \
##             sp.einsum('ij,kl', sp.logical_and(rotX>=14,rotY<7), rotMatCorner) + \
##             sp.einsum('ij,kl', sp.logical_and(rotX>=14,sp.logical_and(rotY>=7,rotY<14)), rotMatArmX) + \
##             sp.einsum('ij,kl', sp.logical_and(rotX>=14,rotY>=14), rotMatCorner)

#####################################################################
# Input for Fig. 6

##im = ni.imread("tiles.png").astype('float')
##imDX = im[1:-1,2:] - im[1:-1,:-2]
##imDY = im[2:,1:-1] - im[:-2,1:-1]

##testImg = sp.zeros((im.shape[0]-2, im.shape[1]-2, 2,2))
##testImg[:,:,0,0] = imDX*imDX
##testImg[:,:,0,1] = imDX*imDY
##testImg[:,:,1,0] = testImg[:,:,0,1]
##testImg[:,:,1,1] = imDY*imDY

##testImg = testImg[151:151+30,68:68+30]
##testImg *= 2.0/testImg.max()

#nrrd.write('test-img.nrrd',
#           sp.concatenate([testImg[:,:,0,0,sp.newaxis],testImg[:,:,1,1,sp.newaxis],testImg[:,:,0,1,sp.newaxis]], axis=2).astype('float32'),
#           options={'encoding': 'raw'}, separate_header=True)
#nrrd.write('rot-test-img.nrrd',
#           sp.concatenate([rotTestImg[:,:,0,0,sp.newaxis],rotTestImg[:,:,1,1,sp.newaxis],rotTestImg[:,:,0,1,sp.newaxis]], axis=2).astype('float32'),
#           options={'encoding': 'raw'}, separate_header=True)

#####################################################################
# Output

def linearC_to_sC(C):
    if C<=0.0031308:
        return 12.92*C
    else:
        return 1.055*sp.power(C,1/2.4)-0.055

def matrixToRGB(M):
    # Note: this assumes a trace in the range [0,5*sqrt(2)]
    x,y,z = sp.sqrt(0.5)*sp.array((M[0,1]+M[1,0], M[1,1]-M[0,0], M[1,1]+M[0,0]))
    H,C,L = (sp.mod(sp.arctan2(y,x)*(3/sp.pi),6), sp.hypot(x,y), 0.2*z) # 3/sp.pi = 6/(2*sp.pi)
    L = max(0,min(1,L))
    C = min(1-abs(2*L-1),C)
    X = C*(1-abs(sp.mod(H,2)-1))
    if H<1:
        R,G,B = (C,X,0)
    elif H<2:
        R,G,B = (X,C,0)
    elif H<3:
        R,G,B = (0,C,X)
    elif H<4:
        R,G,B = (0,X,C)
    elif H<5:
        R,G,B = (X,0,C)
    else:
        R,G,B = (C,0,X)
    m = L - 0.5*C
    R,G,B = (R+m, G+m, B+m)
    return sp.clip((linearC_to_sC(R),linearC_to_sC(G),linearC_to_sC(B)),0,1)

def saveImg(img,fileName):
    saveImgFrame(imgToFrame(img),fileName)
    #width = img.shape[1]
    #height = img.shape[0]
    #xscale = 1.0/(2*width)
    #yscale = 1.0/(2*height)
    #fig = plt.figure(figsize=(5,5))
    #ax = fig.add_axes([0, 0, 1, 1])
    #ax.axis('off')
    #patches = []
    #for r in range(height):
    #    for c in range(width):
    #        w,v = la.eigh(img[r,c])
    #        a = sp.arctan2(v[1,0],v[0,0])
    #        patches.append(mpatches.Ellipse([(2*c+1)*xscale,(2*r+1)*yscale],w[0]*xscale,w[1]*yscale,angle=a*180/sp.pi,facecolor='0.7',edgecolor='none'))
    #collection = PatchCollection(patches,cmap=mpl.cm.gray,match_original=True)
    #ax.add_collection(collection)
    #plt.savefig(fileName)

def saveImgFrame(img,fileName):
    useColors = False
    useEdges = False
    width = img.shape[1]
    height = img.shape[0]
    xscale = 1.0/(2*width)
    yscale = 1.0/(2*height)
    coords = sp.zeros((len(actualAngles2),2))
    coordsPos = sp.zeros((len(actualAngles2),2))
    coordsNeg = sp.zeros((len(actualAngles2),2))
    with open(fileName, "wb") as imgf:
        imgf.write('<?xml version="1.0" standalone="no"?>\n<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" \n  "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">\n<svg width="5cm" height="5cm" viewBox="0 0 1 1" version="1.1" xmlns="http://www.w3.org/2000/svg">'.encode('utf-8'))
        for r in range(height):
            for c in range(width):
                for i,j in zip(range(len(angleOrder2)),angleOrder2):
                    angle = actualAngles2[j]
                    value = img[r,c,j%len(actualAngles)]
                    coords[i] = [(2*c+1+0.5*value*sp.cos(angle))*xscale, (2*r+1+0.5*value*sp.sin(angle))*yscale]
                    coordsPos[i] = [(2*c+1+0.5*max(value,0)*sp.cos(angle))*xscale, (2*r+1+0.5*max(value,0)*sp.sin(angle))*yscale]
                    coordsNeg[i] = [(2*c+1+0.5*min(value,0)*sp.cos(angle))*xscale, (2*r+1+0.5*min(value,0)*sp.sin(angle))*yscale]
                imgf.write('  <polygon points="' + string.join(map(lambda (x,y):"%.4g,%.4g" % (x,y), coordsPos)) + '"' +
                                   ' fill="rgb(' + string.join(map(lambda c:"%d" % round(255*c), matrixToRGB(frametomat(img[r,c])) if useColors else [0.7,0.7,0.7]), sep=',') + ')"' +
                                   ' stroke="none" />\n')
                if img[r,c].min()<-1e-4:
                    imgf.write('  <polygon points="' + string.join(map(lambda (x,y):"%.4g,%.4g" % (x,y), coordsNeg)) + '"' +
                                       ' fill="rgb(' + string.join(map(lambda c:"%d" % round(255*c), matrixToRGB(frametomat(img[r,c])) if useColors else [0,0,0]), sep=',') + ')"' +
                                       ' stroke="none" />\n')
                if useEdges:
                    imgf.write('  <polygon points="' + string.join(map(lambda (x,y):"%.4g,%.4g" % (x,y), coords)) + '"' +
                                       ' fill="none"' +
                                       ' stroke="rgb(128,128,128)" />\n')
        imgf.write('</svg>'.encode('utf-8'))
##    fig = plt.figure(figsize=(5,5))
##    fig.patch.set_facecolor('none')
##    fig.patch.set_alpha(0)
##    ax = fig.add_axes([0, 0, 1, 1])
##    ax.axis('off')
##    ax.patch.set_facecolor('none')
##    ax.patch.set_alpha(0)
##    patches = []
##    coords = sp.zeros((len(actualAngles2),2))
##    for r in range(height):
##        for c in range(width):
##            for i,j in zip(range(len(angleOrder2)),angleOrder2):
##                angle = actualAngles2[j]
##                value = img[r,c,j%len(actualAngles)]
##                coords[i] = [(2*c+1+0.5*value*sp.cos(angle))*xscale, (2*r+1+0.5*value*sp.sin(angle))*yscale]
##            patches.append(mpatches.Polygon(coords,
##                                            facecolor=matrixToRGB(frametomat(img[r,c])) if useColors else '0.7',
##                                            edgecolor='0.5' if useEdges else 'none',
##                                            closed=True))
##    collection = PatchCollection(patches,cmap=mpl.cm.gray,match_original=True)
##    ax.add_collection(collection)
##    plt.savefig(fileName, facecolor=fig.get_facecolor())
##    plt.close()

#####################################################################
# Minimum covering circle of points

def pointEnclosedIn(P, C):
    return la.norm(P-C[:2])<=C[2]+1e-6

def MB(B):
    d = B.shape[1]
    # Should always get d+1 points or less in B
    if B.shape[0]==0:
        # Truely empty sphere
        D = sp.zeros(d+1)
        D[-1] = -1
    elif B.shape[0]==1:
        # Just a single point
        D = sp.zeros(d+1)
        D[:-1] = B[0]
        D[-1] = 0
    else:
        # We solve the following system of len(B) equations, with (cx,cy) on the affine hull (worked out for 2D):
        #   (x0-cx)^2 + (y0-cy)^2 = cr^2
        #   (x1-cx)^2 + (y1-cy)^2 = cr^2
        #   ...
        # To do so, we first subtract x0 from all coordinates, getting:
        #               cx'^2 + cy'^2 = (cr-r0)^2
        #   (x1'-cx')^2 + (y1'-cy')^2 = (cr-r1)^2
        #   ...
        # Writing (cx,cy) as an affine combination of (x1',y1'), (x2',y2'), etc., we can get len(B)-1 equations:
        #   2*(x1^2+y1^2)*l1 + 2*(x1*x2+y1*y2)*l2 + ... = x1^2+y1^2
        #   2*(x2*x1+y2*y1)*l1 + 2*(x2^2+y2^2)*l2 + ... = x2^2+y2^2
        #   ...
        Ba = B[1:] - B[0]
        A = 2*sp.dot(Ba,Ba.T)
        b = sp.square(Ba).sum(axis=1)
        try:
            Lambda = la.solve(A,b)
        except la.LinAlgError as e:
            print(B)
            raise e
        D = sp.zeros(d+1)
        D[:d] = sp.dot(Ba.T,Lambda)
        D[-1] = la.norm(D[:d])
        D[:d] += B[0]
    return D

def mtf_mb(L, B):
    d = B.shape[1]
    mb = MB(B)
    if B.shape[0]==d+1:
        return mb
    for i,pi in zip(range(len(L)),L):
        if not pointEnclosedIn(pi,mb):
            mb = mtf_mb(L[:i], sp.append(B, [pi], axis=0))
            L[:i+1] = sp.roll(L[:i+1], 1, axis=0)
    return mb

#####################################################################
# Minimum covering circle of circles

def enclosedIn(A,B):
    return la.norm(A[:2]-B[:2])+A[2]<=B[2]+1e-6

# TODO: Make miniCircle work more like mtf_mb (in particular the lack of reliance on a specific number of dimensions), also see:
# http://www.inf.ethz.ch/personal/gaertner/miniball.html
# Solution Methodologies for the Smallest Enclosing Circle Problem (where miniCircle came from)
def miniCircle(C, B):
    if C.size==0:
        if B.shape[0]==0:
            D = sp.array([0,0,-1])
        elif B.shape[0]==1:
            D = B[0].copy()
        elif B.shape[0]==2:
            if enclosedIn(B[0],B[1]): # 0 enclosed in 1
                D = B[1].copy()
            elif enclosedIn(B[1],B[0]): # 1 enclosed in 0
                D = B[0].copy()
            else: # neither enclosed in the other, so difflen != 0
                diff = B[1,:2]-B[0,:2]
                difflen = la.norm(diff)
                diff /= difflen
                fp0 = B[0,:2]-diff*B[0,2] # Far point of circle B[0]
                fp1 = B[1,:2]+diff*B[1,2] # Far point of circle B[1]
                D = sp.array([(fp0[0]+fp1[0])/2,
                              (fp0[1]+fp1[1])/2,
                              (difflen+B[0,2]+B[1,2])/2])
        else:
            assert False, "Too many circles in B."
    else:
        i = rnd.randint(len(C))
        if i+1<len(C):
            C[[i,-1]] = C[[-1,i]]
        newC = C[:-1] # This is safe, because any "child" invocation can merely remove additional elements
        ci = C[-1]
        D = miniCircle(newC, B)
        if not enclosedIn(ci,D):
            # ci is NOT enclosed in D
            if B.shape[0]<=1:
                D = miniCircle(newC, sp.append(B,[ci],axis=0))
            else: # We now have three (potential) boundary circles
                a1,b1,r1 = B[0]
                a2,b2,r2 = B[1]
                a3,b3,r3 = ci
                try:
                    D = la.solve([[a2-a1, b2-b1, r1-r2],
                                  [a3-a1, b3-b1, r1-r3],
                                  [a2-a3, b2-b3, r3-r2]],
                                 [0.5*((r1*r1-(a1*a1+b1*b1)) - (r2*r2-(a2*a2+b2*b2))),
                                  0.5*((r1*r1-(a1*a1+b1*b1)) - (r3*r3-(a3*a3+b3*b3))),
                                  0.5*((r3*r3-(a3*a3+b3*b3)) - (r2*r2-(a2*a2+b2*b2)))])
                except:
                    print(B[0])
                    print(B[1])
                    print(ci)
                    print(D)
                    raise
    return D

#####################################################################
# Minimum covering circle of circles (subgradient method)
# Based on: Solution Methodologies for the Smallest Enclosing Circle Problem

def sphereDistToPoint(S,P):
    return la.norm(S[0:2]-P) + S[2]

def miniSphere(Ss):
    # Initialize centre to centre of sphere centres
    C = Ss[:,0:2].mean(axis=0)

    def F(x):
        maxdist = -sp.inf
        for S in Ss:
            maxdist = max(maxdist, sphereDistToPoint(S, C+x*direction))
        return maxdist

    indices = range(len(Ss))
    stepSize = 1
    resphi = 2 - (1+sp.sqrt(5))/2
    while stepSize>1e-6:
        # Find farthest spheres (note plural!) from centre
        dists = map(lambda S: sphereDistToPoint(S,C), Ss)
        fdist = max(dists)
        fS = filter(lambda i: dists[i]+1e-6>=fdist, indices)
        assert len(fS)>0
        # Filter out spheres whose centres are too close to C
        fS = filter(lambda i: la.norm(Ss[i,0:2]-C)>1e-6, fS)
        # If a "majority" of the farthest spheres agree on a direction to minimize in, then we find it.
        direction = sum(map(lambda i: (Ss[i,0:2]-C)/la.norm(Ss[i,0:2]-C), fS))
        if la.norm(direction)<1e-6:
            # There is no overall "best" direction, so we're stuck.
            break
        # Scale direction so that the optimum for stepSize will definitely lie in the interval [0,1]
        direction *= max(map(lambda i: sp.dot(direction, (Ss[i,0:2]-C)), fS))/sp.dot(direction,direction)

        # Use Golden section search to find minimum along line segment
        # between C and fS[0:2].
        a,b,c = 0,0.5,1
        Fa,Fb,Fc = fdist,F(b),F(c)
        t = b
        while c-a>1e-8:
            bcLarger = ((c-b)>(b-a))
            t = b + resphi*(c-b) if bcLarger else b - resphi*(b-a)
            Ft = F(t)
            if Ft < Fb:
                if bcLarger:
                    a,b = b,t
                    Fa,Fb = Fb,Ft
                else:
                    b,c = t,b
                    Fb,Fc = Ft,Fb
            else:
                if bcLarger:
                    c = t
                    Fc = Ft
                else:
                    a = t
                    Fa = Ft
        stepSize = a+(c-a)/2
        C += stepSize*direction
    return sp.array([C[0],C[1], F(0)])

#####################################################################
# Conversions between matrices and "spheres"

def mattosphere(M):
    n = M.shape[0]
    tr = sp.trace(M)
    m = M - (float(tr)/n)*sp.identity(n)
    r = tr*sp.sqrt(1-1.0/n)
    return [sp.sqrt(2.0)*m[0,1],(m[1,1]-m[0,0])/sp.sqrt(2.0),r]

def spheretomat(S):
    n = 2
    P = S[:2]
    m = sp.array([[-P[1],P[0]],[P[0],P[1]]])/sp.sqrt(2.0)
    r = S[2]
    M = m + (r/(n*sp.sqrt(1-1.0/n)))*sp.identity(n)
    return M

#####################################################################
# Matrix min/max based on minimum covering circles

#def matmax(Ms,nsteps=23): # 23 steps gives R<Rmin*1.01
def matmax(Ms):
    Ss = sp.array([mattosphere(M) for M in Ms])
    maxS = miniSphere(Ss)
    #maxS = miniCircle(Ss, sp.zeros((0,3)))
    
    #ps = sp.zeros((0,2))
    #myAngles = 2*sp.pi*sp.r_[0:nsteps]/nsteps
    #unitpts = sp.array([sp.cos(myAngles),sp.sin(myAngles)]).T
    #for S in Ss:
    #    # To guarantee finding an upper bound we need to increase R a bit (to make sure the polygon we're implicitly making contains the circle)
    #    # Rmin = cos(\pi/nsteps)*R
    #    # R = Rmin/cos(\pi/nsteps)
    #    Rmin = S[-1]
    #    R = Rmin/sp.cos(sp.pi/nsteps)
    #    #print(Rmin, R, sp.cos(sp.pi/nsteps))
    #    ps = sp.append(ps, S[:-1]+R*unitpts, axis=0)
    #maxS = mtf_mb(ps, sp.zeros((0,2)))
    return spheretomat(maxS)

def matmin(Ms):
    # This is needed to avoid getting negative definite matrices (which apparently do not play well with the code above)
    # But we can get away with a VERY rough estimate (as long as it's an upper bound)
    Mmax = matmax(Ms)
    return Mmax-matmax([Mmax-M for M in Ms])

#####################################################################
# Functions on matrices based on eigenvalues

def applyFunToMat(h,M):
    # function h should apply to scipy arrays
    w,v = la.eigh(M)
    w = h(w)
    return sp.dot(v*w,v.T)

def matsqrt(M):
    return applyFunToMat(lambda w:sp.sqrt(sp.maximum(w,0)), M)
    
def matclipSquare(M):
    return applyFunToMat(lambda w:sp.square(sp.maximum(w,0)), M)

#####################################################################
# Conversions between matrices and their frame representation

numFrameAngles = 31
frameAngleStep = sp.pi/numFrameAngles
frameAngles = frameAngleStep*sp.r_[0:numFrameAngles]
coefficients = sp.zeros((numFrameAngles,3))
coefficients[:,0] = sp.square(sp.cos(frameAngles))
coefficients[:,1] = sp.square(sp.sin(frameAngles))
coefficients[:,2] = sp.sqrt(2)*sp.cos(frameAngles)*sp.sin(frameAngles)
actualAngles = sp.mod((sp.array([0,1,2])*(sp.pi/3)-frameAngles[:,sp.newaxis]).flatten(), 2*sp.pi)
#angleOrder = sp.argsort(actualAngles)
actualAngles2 = sp.mod(sp.concatenate((actualAngles,actualAngles+sp.pi)), 2*sp.pi) # Should also take "opposite" angles into account, because of symmetry of tensors.
angleOrder2 = sp.argsort(actualAngles2)

def mattoframe(M):
    # Assumes a symmetric 2x2 matrix is simply given as a 2x2 (full) matrix
    M00 = M[0,0]
    M11 = M[1,1]
    M01 = (M[0,1]+M[1,0])*sp.sqrt(0.5)
    
    newData = sp.zeros(numFrameAngles*3)
    for j in range(numFrameAngles):
        newData0 = coefficients[j,0]*M00 + coefficients[j,1]*M11 - coefficients[j,2]*M01
        newData1 = coefficients[j,1]*M00 + coefficients[j,0]*M11 + coefficients[j,2]*M01
        newData2 = coefficients[j,2]*(M00-M11) + (coefficients[j,0]-coefficients[j,1])*M01
        newData[j*3+0] = newData0
        newData[j*3+1] = (newData0 + 3*newData1 + sp.sqrt(6)*newData2)/4
        newData[j*3+2] = (newData0 + 3*newData1 - sp.sqrt(6)*newData2)/4
    return newData

def frametomat(F):
    M00 = 0
    M11 = 0
    M01 = 0
    for j in range(numFrameAngles):
        newData0 = F[j*3+0]
        newData1 = (2*(F[j*3+1]+F[j*3+2]) - F[j*3+0])/3
        newData2 = sp.sqrt(2/3.0)*(F[j*3+1] - F[j*3+2])
        M00 += coefficients[j,0]*newData0 + coefficients[j,1]*newData1 + coefficients[j,2]*newData2
        M11 += coefficients[j,1]*newData0 + coefficients[j,0]*newData1 - coefficients[j,2]*newData2
        M01 += coefficients[j,2]*(newData1-newData0) + (coefficients[j,0]-coefficients[j,1])*newData2
    M01 *= sp.sqrt(0.5)
    M = sp.array([[M00,M01],[M01,M11]])/numFrameAngles
    return M

# Create a "frame" version of the test image
def imgToFrame(img):
    imgFrame = sp.zeros(img.shape[0:2] + (numFrameAngles*3,))
    for r,c in sp.ndindex(img.shape[0:2]):
        imgFrame[r,c] = mattoframe(img[r,c])
    return imgFrame
def imgFromFrame(imgFrame):
    img = sp.zeros(imgFrame.shape[0:2] + (2,2))
    for r,c in sp.ndindex(img.shape[0:2]):
        img[r,c] = frametomat(imgFrame[r,c])
    return img
testImgFrame = imgToFrame(testImg)
##rotTestImgFrame = imgToFrame(rotTestImg)

#####################################################################
# Extra projections

def imgFromFrameLSUB(imgFrame):
    img = sp.zeros(imgFrame.shape[0:2] + (2,2))
    vectomat = lambda v: sp.array([[v[0],v[1]],[v[1],v[2]]])
    for r,c in sp.ndindex(img.shape[0:2]):
        maxval = imgFrame[r,c].max()
        fun = lambda v: sp.square(mattoframe(vectomat(v))-imgFrame[r,c]).sum()
        img[r,c] = vectomat(opt.minimize(fun, sp.array([maxval,0.0,maxval]),
                                         method='SLSQP',
                                         constraints={'type':'ineq', 'fun': lambda v: (mattoframe(vectomat(v))-imgFrame[r,c]).min()}).x)
    return img

def imgFromFrameLUB(imgFrame):
    img = sp.zeros(imgFrame.shape[0:2] + (2,2))
    vectomat = lambda v: sp.array([[v[0],v[1]],[v[1],v[2]]])
    for r,c in sp.ndindex(img.shape[0:2]):
        maxval = imgFrame[r,c].max()
        fun = lambda v: v[0]+v[2]+1e-6*sp.square(mattoframe(vectomat(v))-imgFrame[r,c]).sum()
        img[r,c] = vectomat(opt.minimize(fun, sp.array([maxval,0.0,maxval]),
                                         method='SLSQP',
                                         constraints={'type':'ineq', 'fun': lambda v: (mattoframe(vectomat(v))-imgFrame[r,c]).min()}).x)
    return img

#####################################################################
# Matrix min/max based on frames

def framemax(Ms):
    FMs = sp.array([mattoframe(M) for M in Ms])
    Fmax = FMs.max(axis=0)
    return frametomat(Fmax)

def framemin(Ms):
    FMs = sp.array([mattoframe(M) for M in Ms])
    Fmax = FMs.min(axis=0)
    return frametomat(Fmax)

#####################################################################
# Functions on matrices based on frame representation

def applyFunToMatFrame(h,M):
    # function h should apply to scipy arrays
    return frametomat(h(mattoframe(M)))

def framesqrt(M):
    return applyFunToMatFrame(lambda w:sp.sqrt(sp.maximum(w,0)), M)
    
def frameclipSquare(M):
    return applyFunToMatFrame(lambda w:sp.square(sp.maximum(w,0)), M)

#####################################################################
# Structural erosion/dilation

def erode(img, se, minfun=matmin):
    newImg = sp.zeros(img.shape)
    width = img.shape[1]
    height = img.shape[0]
    for r,c in sp.ndindex(img.shape[0:2]):
        vals = []
        for ro,co in se:
            if r+ro<0 or r+ro>=height or c+co<0 or c+co>=width:
                continue
            vals.append(img[r+ro,c+co])
        if len(vals)>0:
            newImg[r,c] = minfun(vals)
    return newImg

def dilate(img, se, maxfun=matmax):
    newImg = sp.zeros(img.shape)
    width = img.shape[1]
    height = img.shape[0]
    for r,c in sp.ndindex(img.shape[0:2]):
        vals = []
        for ro,co in se:
            if r+ro<0 or r+ro>=height or c+co<0 or c+co>=width:
                continue
            vals.append(img[r+ro,c+co])
        if len(vals)>0:
            newImg[r,c] = maxfun(vals)
    return newImg

#####################################################################
# PDE-based erosion/dilation

def morphPDE(img, stopTime, sign, sqrt, clipSquare):
    newImg = img.copy()
    width = img.shape[1]
    height = img.shape[0]
    valueShape = img.shape[2:]
    tau = 0.5
    
    time = 0
    while time+0.5*tau<stopTime:
        Dx = sp.zeros((height,width+1)+valueShape)
        Dx[:,1:-1] = newImg[:,1:]-newImg[:,:-1]

        Dy = sp.zeros((height+1,width)+valueShape)
        Dy[1:-1] = newImg[1:]-newImg[:-1]
        
        for r,c in sp.ndindex(img.shape[0:2]):
            #newImg[r,c] = newImg[r,c] + sign*tau*matsqrt(matsquare(matclip(-sign*Dx[r,c])) + matsquare(matclip(sign*Dx[r,c+1])) +
            #                                             matsquare(matclip(-sign*Dy[r,c])) + matsquare(matclip(sign*Dy[r+1,c])))
            newImg[r,c] = newImg[r,c] + sign*tau*sqrt(clipSquare(-sign*Dx[r,c]) + clipSquare(sign*Dx[r,c+1]) +
                                                      clipSquare(-sign*Dy[r,c]) + clipSquare(sign*Dy[r+1,c]))

        time += tau
    
    return newImg

def erodePDE(img, stopTime, sqrt, clipSquare):
    return morphPDE(img, stopTime, -1, sqrt, clipSquare)

def dilatePDE(img, stopTime, sqrt, clipSquare):
    return morphPDE(img, stopTime, 1, sqrt, clipSquare)

#####################################################################
# Structuring element

# radius 1
ball = [(0,-1),(-1,0),(0,0),(1,0),(0,1)] 

# radius 2
#ball = [(0,-2),(-1,-1),(0,-1),(1,-1),(-2,0),(-1,0),(0,0),(1,0),(2,0),(-1,1),(0,1),(1,1),(0,2)]

# radius 3
#ball = [(-3,0),(-2,-2),(-2,-1),(-2,0),(-2,1),(-2,2),(-1,-2),(-1,-1),(-1,0),(-1,1),(-1,2),(0,-3),(0,-2),(0,-1),(0,0),(0,1),(0,2),(0,3),(1,-2),(1,-1),(1,0),(1,1),(1,2),(2,-2),(2,-1),(2,0),(2,1),(2,2),(3,0)]

# radius 4
#ball = [(-4,0),(-3,-2),(-3,-1),(-3,0),(-3,1),(-3,2),(-2,-3),(-2,-2),(-2,-1),(-2,0),(-2,1),(-2,2),(-2,3),(-1,-3),(-1,-2),(-1,-1),(-1,0),(-1,1),(-1,2),(-1,3),(0,-4),(0,-3),(0,-2),(0,-1),(0,0),(0,1),(0,2),(0,3),(0,4),(1,-3),(1,-2),(1,-1),(1,0),(1,1),(1,2),(1,3),(2,-3),(2,-2),(2,-1),(2,0),(2,1),(2,2),(2,3),(3,-2),(3,-1),(3,0),(3,1),(3,2),(4,0)]

# radius 5
#ball = [(-5,0),(-4,-3),(-4,-2),(-4,-1),(-4,0),(-4,1),(-4,2),(-4,3),(-3,-4),(-3,-3),(-3,-2),(-3,-1),(-3,0),(-3,1),(-3,2),(-3,3),(-3,4),(-2,-4),(-2,-3),(-2,-2),(-2,-1),(-2,0),(-2,1),(-2,2),(-2,3),(-2,4),(-1,-4),(-1,-3),(-1,-2),(-1,-1),(-1,0),(-1,1),(-1,2),(-1,3),(-1,4),(0,-5),(0,-4),(0,-3),(0,-2),(0,-1),(0,0),(0,1),(0,2),(0,3),(0,4),(0,5),(1,-4),(1,-3),(1,-2),(1,-1),(1,0),(1,1),(1,2),(1,3),(1,4),(2,-4),(2,-3),(2,-2),(2,-1),(2,0),(2,1),(2,2),(2,3),(2,4),(3,-4),(3,-3),(3,-2),(3,-1),(3,0),(3,1),(3,2),(3,3),(3,4),(4,-3),(4,-2),(4,-1),(4,0),(4,1),(4,2),(4,3),(5,0)]

#####################################################################
# Generate output

extension = ".svg"

try:
    os.makedirs("out")
except:
    pass

#saveImg(testImg[1:-1,1:-1],'out/input'+extension)
saveImg(testImg,'out/input'+extension)
#saveImg(rotTestImg,'out/rot-input'+extension)

#saveImg(erode(testImg, ball, minfun=lambda vals:sp.array(vals).min(axis=0)),'out/erodedComponentWise'+extension)
#saveImg(erode(testImg, ball, minfun=matmin),'out/erodedLoewner'+extension)
#saveImg(erode(testImg, ball, minfun=framemin),'out/erodedFrame'+extension)
#saveImgFrame(erode(testImgFrame, ball, minfun=lambda vals:sp.array(vals).min(axis=0)),'out/erodedFrame-noproject'+extension)
#saveImg(erodePDE(testImg, 2, matsqrt, matclipSquare),'out/erodedPDE'+extension)
#saveImg(erodePDE(testImg, 2, framesqrt, frameclipSquare),'out/erodedPDE-frame'+extension)
#saveImgFrame(erodePDE(testImgFrame, 2, sp.sqrt, lambda w:sp.square(sp.maximum(w,0))),'out/erodedPDE-frame-noproject'+extension)

#saveImg(dilate(testImg, ball, maxfun=lambda vals:sp.array(vals).max(axis=0)),'out/dilatedComponentWise'+extension)
#saveImg(dilate(testImg, ball, maxfun=matmax),'out/dilatedLoewner'+extension)
#saveImg(dilate(testImg, ball, maxfun=framemax),'out/dilatedFrame'+extension)
#saveImgFrame(dilate(testImgFrame, ball, maxfun=lambda vals:sp.array(vals).max(axis=0)),'out/dilatedFrame-noproject'+extension)
#saveImg(dilatePDE(testImg, 2, matsqrt, matclipSquare),'out/dilatedPDE'+extension)
#saveImg(dilatePDE(testImg, 2, framesqrt, frameclipSquare),'out/dilatedPDE-frame'+extension)
#saveImgFrame(dilatePDE(testImgFrame, 2, sp.sqrt, lambda w:sp.square(sp.maximum(w,0))),'out/dilatedPDE-frame-noproject'+extension)

saveImg(erode(dilate(testImg, ball, maxfun=matmax), ball, minfun=matmin)[1:-1,1:-1],'out/closedLoewner'+extension)
#saveImg(erode(dilate(testImg, ball, maxfun=framemax), ball, minfun=framemin)[1:-1,1:-1],'out/closedFrame'+extension)
saveImgFrame(erode(dilate(testImgFrame, ball, maxfun=lambda vals:sp.array(vals).max(axis=0)), ball, minfun=lambda vals:sp.array(vals).min(axis=0))[1:-1,1:-1],'out/closedFrame-noproject'+extension)
#saveImg(imgFromFrame(erode(dilate(testImgFrame, ball, maxfun=lambda vals:sp.array(vals).max(axis=0)), ball, minfun=lambda vals:sp.array(vals).min(axis=0)))[1:-1,1:-1],'out/closedFrame-finalprojectF'+extension)
#saveImg(imgFromFrameLSUB(erode(dilate(testImgFrame, ball, maxfun=lambda vals:sp.array(vals).max(axis=0)), ball, minfun=lambda vals:sp.array(vals).min(axis=0)))[1:-1,1:-1],'out/closedFrame-finalprojectLSUB'+extension)
saveImg(imgFromFrameLUB(erode(dilate(testImgFrame, ball, maxfun=lambda vals:sp.array(vals).max(axis=0)), ball, minfun=lambda vals:sp.array(vals).min(axis=0)))[1:-1,1:-1],'out/closedFrame-finalprojectLUB'+extension)

#saveImg(erode(dilate(testImg, ball, maxfun=matmax), ball, minfun=matmin),'out/closedLoewner'+extension)
#saveImg(erode(dilate(testImg, ball, maxfun=framemax), ball, minfun=framemin)[1:-1,1:-1],'out/closedFrame'+extension)
#saveImgFrame(erode(dilate(testImgFrame, ball, maxfun=lambda vals:sp.array(vals).max(axis=0)), ball, minfun=lambda vals:sp.array(vals).min(axis=0)),'out/closedFrame-noproject'+extension)
#saveImg(imgFromFrame(erode(dilate(testImgFrame, ball, maxfun=lambda vals:sp.array(vals).max(axis=0)), ball, minfun=lambda vals:sp.array(vals).min(axis=0))),'out/closedFrame-finalprojectF'+extension)
#saveImg(imgFromFrameLSUB(erode(dilate(testImgFrame, ball, maxfun=lambda vals:sp.array(vals).max(axis=0)), ball, minfun=lambda vals:sp.array(vals).min(axis=0))),'out/closedFrame-finalprojectLSUB'+extension)
#saveImg(imgFromFrameLUB(erode(dilate(testImgFrame, ball, maxfun=lambda vals:sp.array(vals).max(axis=0)), ball, minfun=lambda vals:sp.array(vals).min(axis=0))),'out/closedFrame-finalprojectLUB'+extension)

#saveImg(erode(rotTestImg, ball, minfun=lambda vals:sp.array(vals).min(axis=0)),'out/rot-erodedComponentWise'+extension)
#saveImg(erode(rotTestImg, ball, minfun=matmin),'out/rot-erodedLoewner'+extension)
#saveImg(erode(rotTestImg, ball, minfun=framemin),'out/rot-erodedFrame'+extension)
#saveImgFrame(erode(rotTestImgFrame, ball, minfun=lambda vals:sp.array(vals).min(axis=0)),'out/rot-erodedFrame-noproject'+extension)
#saveImg(erodePDE(rotTestImg, 2, matsqrt, matclipSquare),'out/rot-erodedPDE'+extension)
#saveImg(erodePDE(rotTestImg, 2, framesqrt, frameclipSquare),'out/rot-erodedPDE-frame'+extension)
#saveImgFrame(erodePDE(rotTestImgFrame, 2, sp.sqrt, lambda w:sp.square(sp.maximum(w,0))),'out/rot-erodedPDE-frame-noproject'+extension)

#saveImg(dilate(rotTestImg, ball, maxfun=lambda vals:sp.array(vals).max(axis=0)),'out/rot-dilatedComponentWise'+extension)
#saveImg(dilate(rotTestImg, ball, maxfun=matmax),'out/rot-dilatedLoewner'+extension)
#saveImg(dilate(rotTestImg, ball, maxfun=framemax),'out/rot-dilatedFrame'+extension)
#saveImgFrame(dilate(rotTestImgFrame, ball, maxfun=lambda vals:sp.array(vals).max(axis=0)),'out/rot-dilatedFrame-noproject'+extension)
#saveImg(dilatePDE(rotTestImg, 2, matsqrt, matclipSquare),'out/rot-dilatedPDE'+extension)
#saveImg(dilatePDE(rotTestImg, 2, framesqrt, frameclipSquare),'out/rot-dilatedPDE-frame'+extension)
#saveImgFrame(dilatePDE(rotTestImgFrame, 2, sp.sqrt, lambda w:sp.square(sp.maximum(w,0))),'out/rot-dilatedPDE-frame-noproject'+extension)
